#include "header.h"

void put_open (TM *tm) {
  GtkWidget *dialog;
  GError **error = NULL;
  char *filename;
  int emit;

  dialog = gtk_file_chooser_dialog_new("Open Image", NULL, GTK_FILE_CHOOSER_ACTION_OPEN,
				       GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				       GTK_STOCK_OPEN, GTK_RESPONSE_OK, NULL);
  emit = gtk_dialog_run(GTK_DIALOG(dialog));
  if (emit == GTK_RESPONSE_OK) {
    filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
    gtk_widget_destroy(dialog);
    //    get_full_path(tm);
    //    strcpy(tm->tnfo->image_path, filename);
    tm->tnfo->image_full_path = malloc(strlen(filename) + 1);
    if (!tm->tnfo->image_full_path) {
      criterr(0);
    }

    strcpy(tm->tnfo->image_full_path, filename);
    get_dirname(tm);
    fill_image_list(tm);

    if (tm->tgtk->image != NULL) {
      gtk_widget_destroy(tm->tgtk->image);
    }

    put_left_sidebar(tm);
    if (strcmp(tm->tcfg->show_left_sidebar, "yes") == 0) {
      gtk_widget_show_all(tm->tgtk->notebook1);
    }

    if (check_ext(tm->tnfo->image_full_path) == 2) {
      tm->tgtk->animation = gdk_pixbuf_animation_new_from_file(tm->tnfo->image_full_path, error);
      tm->tgtk->image = gtk_image_new_from_animation(tm->tgtk->animation);
      tm->tgtk->animation_orig = tm->tgtk->animation;
    } else {
      tm->tgtk->pixbuf = gdk_pixbuf_new_from_file(tm->tnfo->image_full_path, error);
      tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
      tm->tgtk->pixbuf_orig = tm->tgtk->pixbuf; // save a copy of the original image
    }
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
    gtk_widget_show(tm->tgtk->image);

    fill_nfo(tm);
    fill_right_sidebar(tm);
    put_status(tm);

  } else {
    gtk_widget_destroy(dialog);
  }
}

void put_save (TM *tm) {
  // not implemented yet, skeleton function
}

void put_save_as (TM *tm) {
  // not implemented yet, skeleton function
}
